Subject: Re: [PATCH] pktgen handle netdev device getting full.

From: "David S. Miller" <[email-masked]>
Date: Thu, 16 Sep 2004 15:59:13 -0700

On Thu, 16 Sep 2004 15:59:30 -0700
Ben Greear <[email-masked]> wrote:

> Stephen Hemminger wrote:
> > I was trying out pktgen on a NIC with an undersized ring, so 
> > hard_start_xmit would always return non-zero when full.  This caused a slew
> > of console messages.  Better to just have pktgen retry in this case.
> 
> My understanding is that if the queue is not stopped, then you
> should not get the hard xmit errors.  So, in a proper driver,
> you should not see these printks.

That is absolutely correct, that is why Stephen's patch is
not correct (aside from the do_div() part which I'll happily
apply if submitted by itself).

> By the way, is there any interest in adding my patch that also allows
> pktgen to receive packets (and count the statistics, etc)?  I know
> DaveM objected to the hook in the skb-receive logic some time back,
> but maybe he has a different opinion now?

I still object to this, it will be abused.